<html>

<head>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>

    <script src="https://cdn.jsdelivr.net/npm/axios@0.12.0/dist/axios.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/lodash@4.13.1/lodash.min.js"></script>
</head>

<body>
    <div id="example">
        <p>Thông điệp ban đầu: "{{ message }}"</p>
        <p>Thông điệp bị đảo ngược bằng tính toán (computed): "{{ reversedMessage }}"</p>
    </div>

    <p>Thông điệp bị đảo ngược: "{{ reverseMessage() }}"</p>

    <div id="demo">{{ fullName }}</div>


    <div id="watch-example">
        <p>
            Hãy hỏi một câu hỏi yes/no:
            <input v-model="question">
        </p>
        <p>{{ answer }}</p>
    </div>
    <script>
 
        var vm = new Vue({
            el: '#example',
            data: {
                message: 'người đông bến đợi thuyền xuôi ngược'
            },
            computed: {
                // một computed getter
                reversedMessage: function () {
                    // `this` trỏ tới đối tượng vm
                    return this.message.split(' ').reverse().join(' ')
                }
            }
        })

        // Computed và watched
        // var vm = new Vue({
        //   el: '#demo',
        //   data: {
        //     firstName: 'Trần',
        //     lastName: 'Lập',
        //     fullName: 'Trần Lập'
        //   },
        //   watch: {
        //     firstName: function (val) {
        //       this.fullName = val + ' ' + this.lastName
        //     },
        //     lastName: function (val) {
        //       this.fullName = this.firstName + ' ' + val
        //     }
        //   }
        // })

        var vm = new Vue({
            el: '#demo',
            data: {
                firstName: 'Evan',
                lastName: 'You'
            },
            computed: {
                fullName: function () {
                    return this.firstName + ' ' + this.lastName
                }
            }
        })

        var watchExampleVM = new Vue({
            el: '#watch-example',
            data: {
                question: '',
                answer: 'Không thể trả lời nếu bạn chưa đặt câu hỏi!'
            },
            watch: {
                // bất cứ lúc nào câu hỏi thay đổi, hàm bên dưới sẽ chạy
                question: function (newQuestion, oldQuestion) {
                    this.answer = 'Đang chờ bạn đặt xong câu hỏi...'
                    this.getAnswer()
                }
            },
            methods: {
                // _.debounce là một hàm do Lodash cung cấp
                // Để tìm hiểu rõ hơn cách hoạt động của hàm này,
                // bạn có thể truy cập: https://lodash.com/docs#debounce 
                getAnswer: _.debounce(
                    function () {
                        if (this.question.indexOf('?') === -1) {
                            this.answer = 'Câu hỏi thì thường chứa một dấu "?" ;-)'
                            return
                        }
                        this.answer = 'Đang suy nghĩ...'
                        var vm = this
                        axios.get('https://yesno.wtf/api')
                            .then(function (response) {
                                vm.answer = _.capitalize(response.data.answer)
                            })
                            .catch(function (error) {
                                vm.answer = 'Lỗi! Không thể truy cập API. ' + error
                            })
                    },
                    // Đây là thời gian (đơn vị mili giây) chúng ta đợi người dùng dừng gõ.
                    500
                )
            }
        })
    </script>
    </script>
</body>

</html>